// Code generated by help.awk. DO NOT EDIT.
// GENERATED FILE DO NOT EDIT

package parser

var helpMessages = map[string]HelpMessageBody{
	//line sql.y: 1063
	`ALTER`: {
		//line sql.y: 1064
		Category: hGroup,
		//line sql.y: 1065
		Text: `ALTER TABLE, ALTER INDEX, ALTER VIEW, ALTER SEQUENCE, ALTER DATABASE, ALTER USER
`,
	},
	//line sql.y: 1079
	`ALTER TABLE`: {
		ShortDescription: `change the definition of a table`,
		//line sql.y: 1080
		Category: hDDL,
		//line sql.y: 1081
		Text: `
ALTER TABLE [IF EXISTS] <tablename> <command> [, ...]

Commands:
  ALTER TABLE ... ADD [COLUMN] [IF NOT EXISTS] <colname> <type> [<qualifiers...>]
  ALTER TABLE ... ADD <constraint>
  ALTER TABLE ... DROP [COLUMN] [IF EXISTS] <colname> [RESTRICT | CASCADE]
  ALTER TABLE ... DROP CONSTRAINT [IF EXISTS] <constraintname> [RESTRICT | CASCADE]
  ALTER TABLE ... ALTER [COLUMN] <colname> {SET DEFAULT <expr> | DROP DEFAULT}
  ALTER TABLE ... ALTER [COLUMN] <colname> DROP NOT NULL
  ALTER TABLE ... RENAME TO <newname>
  ALTER TABLE ... RENAME [COLUMN] <colname> TO <newname>
  ALTER TABLE ... VALIDATE CONSTRAINT <constraintname>
  ALTER TABLE ... SPLIT AT <selectclause>
  ALTER TABLE ... SCATTER [ FROM ( <exprs...> ) TO ( <exprs...> ) ]

Column qualifiers:
  [CONSTRAINT <constraintname>] {NULL | NOT NULL | UNIQUE | PRIMARY KEY | CHECK (<expr>) | DEFAULT <expr>}
  FAMILY <familyname>, CREATE [IF NOT EXISTS] FAMILY [<familyname>]
  REFERENCES <tablename> [( <colnames...> )]
  COLLATE <collationname>

`,
		//line sql.y: 1103
		SeeAlso: `WEBDOCS/alter-table.html
`,
	},
	//line sql.y: 1115
	`ALTER VIEW`: {
		ShortDescription: `change the definition of a view`,
		//line sql.y: 1116
		Category: hDDL,
		//line sql.y: 1117
		Text: `
ALTER VIEW [IF EXISTS] <name> RENAME TO <newname>
`,
		//line sql.y: 1119
		SeeAlso: `WEBDOCS/alter-view.html
`,
	},
	//line sql.y: 1126
	`ALTER SEQUENCE`: {
		ShortDescription: `change the definition of a sequence`,
		//line sql.y: 1127
		Category: hDDL,
		//line sql.y: 1128
		Text: `
ALTER SEQUENCE [IF EXISTS] <name>
  [INCREMENT <increment>]
  [MINVALUE <minvalue> | NO MINVALUE]
  [MAXVALUE <maxvalue> | NO MAXVALUE]
  [START <start>]
  [[NO] CYCLE]
ALTER SEQUENCE [IF EXISTS] <name> RENAME TO <newname>
`,
	},
	//line sql.y: 1151
	`ALTER USER`: {
		ShortDescription: `change user properties`,
		//line sql.y: 1152
		Category: hPriv,
		//line sql.y: 1153
		Text: `
ALTER USER [IF EXISTS] <name> WITH PASSWORD <password>
`,
		//line sql.y: 1155
		SeeAlso: `CREATE USER
`,
	},
	//line sql.y: 1160
	`ALTER DATABASE`: {
		ShortDescription: `change the definition of a database`,
		//line sql.y: 1161
		Category: hDDL,
		//line sql.y: 1162
		Text: `
ALTER DATABASE <name> RENAME TO <newname>
`,
		//line sql.y: 1164
		SeeAlso: `WEBDOCS/alter-database.html
`,
	},
	//line sql.y: 1175
	`ALTER INDEX`: {
		ShortDescription: `change the definition of an index`,
		//line sql.y: 1176
		Category: hDDL,
		//line sql.y: 1177
		Text: `
ALTER INDEX [IF EXISTS] <idxname> <command>

Commands:
  ALTER INDEX ... RENAME TO <newname>
  ALTER INDEX ... SPLIT AT <selectclause>
  ALTER INDEX ... SCATTER [ FROM ( <exprs...> ) TO ( <exprs...> ) ]

`,
		//line sql.y: 1185
		SeeAlso: `WEBDOCS/alter-index.html
`,
	},
	//line sql.y: 1500
	`BACKUP`: {
		ShortDescription: `back up data to external storage`,
		//line sql.y: 1501
		Category: hCCL,
		//line sql.y: 1502
		Text: `
BACKUP <targets...> TO <location...>
       [ AS OF SYSTEM TIME <expr> ]
       [ INCREMENTAL FROM <location...> ]
       [ WITH <option> [= <value>] [, ...] ]

Targets:
   TABLE <pattern> [, ...]
   DATABASE <databasename> [, ...]

Location:
   "[scheme]://[host]/[path to backup]?[parameters]"

Options:
   INTO_DB
   SKIP_MISSING_FOREIGN_KEYS

`,
		//line sql.y: 1519
		SeeAlso: `RESTORE, WEBDOCS/backup.html
`,
	},
	//line sql.y: 1527
	`RESTORE`: {
		ShortDescription: `restore data from external storage`,
		//line sql.y: 1528
		Category: hCCL,
		//line sql.y: 1529
		Text: `
RESTORE <targets...> FROM <location...>
        [ AS OF SYSTEM TIME <expr> ]
        [ WITH <option> [= <value>] [, ...] ]

Targets:
   TABLE <pattern> [, ...]
   DATABASE <databasename> [, ...]

Locations:
   "[scheme]://[host]/[path to backup]?[parameters]"

Options:
   INTO_DB
   SKIP_MISSING_FOREIGN_KEYS

`,
		//line sql.y: 1545
		SeeAlso: `BACKUP, WEBDOCS/restore.html
`,
	},
	//line sql.y: 1563
	`IMPORT`: {
		ShortDescription: `load data from file in a distributed manner`,
		//line sql.y: 1564
		Category: hCCL,
		//line sql.y: 1565
		Text: `
IMPORT TABLE <tablename>
       { ( <elements> ) | CREATE USING <schemafile> }
       <format>
       DATA ( <datafile> [, ...] )
       [ WITH <option> [= <value>] [, ...] ]

Formats:
   CSV

Options:
   distributed = '...'
   sstsize = '...'
   temp = '...'
   comma = '...'          [CSV-specific]
   comment = '...'        [CSV-specific]
   nullif = '...'         [CSV-specific]

`,
		//line sql.y: 1583
		SeeAlso: `CREATE TABLE
`,
	},
	//line sql.y: 1674
	`CANCEL`: {
		//line sql.y: 1675
		Category: hGroup,
		//line sql.y: 1676
		Text: `CANCEL JOB, CANCEL QUERY
`,
	},
	//line sql.y: 1682
	`CANCEL JOB`: {
		ShortDescription: `cancel a background job`,
		//line sql.y: 1683
		Category: hMisc,
		//line sql.y: 1684
		Text: `CANCEL JOB <jobid>
`,
		//line sql.y: 1685
		SeeAlso: `SHOW JOBS, PAUSE JOBS, RESUME JOB
`,
	},
	//line sql.y: 1693
	`CANCEL QUERY`: {
		ShortDescription: `cancel a running query`,
		//line sql.y: 1694
		Category: hMisc,
		//line sql.y: 1695
		Text: `CANCEL QUERY <queryid>
`,
		//line sql.y: 1696
		SeeAlso: `SHOW QUERIES
`,
	},
	//line sql.y: 1720
	`CREATE`: {
		//line sql.y: 1721
		Category: hGroup,
		//line sql.y: 1722
		Text: `
CREATE DATABASE, CREATE TABLE, CREATE INDEX, CREATE TABLE AS,
CREATE USER, CREATE VIEW, CREATE SEQUENCE, CREATE STATISTICS,
CREATE ROLE
`,
	},
	//line sql.y: 1743
	`CREATE STATISTICS`: {
		ShortDescription: `create a new table statistic`,
		//line sql.y: 1744
		Category: hMisc,
		//line sql.y: 1745
		Text: `
CREATE STATISTICS <statisticname>
  ON <colname> [, ...]
  FROM <tablename>
`,
	},
	//line sql.y: 1760
	`DELETE`: {
		ShortDescription: `delete rows from a table`,
		//line sql.y: 1761
		Category: hDML,
		//line sql.y: 1762
		Text: `DELETE FROM <tablename> [WHERE <expr>]
              [ORDER BY <exprs...>]
              [LIMIT <expr>]
              [RETURNING <exprs...>]
`,
		//line sql.y: 1766
		SeeAlso: `WEBDOCS/delete.html
`,
	},
	//line sql.y: 1781
	`DISCARD`: {
		ShortDescription: `reset the session to its initial state`,
		//line sql.y: 1782
		Category: hCfg,
		//line sql.y: 1783
		Text: `DISCARD ALL
`,
	},
	//line sql.y: 1795
	`DROP`: {
		//line sql.y: 1796
		Category: hGroup,
		//line sql.y: 1797
		Text: `
DROP DATABASE, DROP INDEX, DROP TABLE, DROP VIEW, DROP SEQUENCE,
DROP USER, DROP ROLE
`,
	},
	//line sql.y: 1813
	`DROP VIEW`: {
		ShortDescription: `remove a view`,
		//line sql.y: 1814
		Category: hDDL,
		//line sql.y: 1815
		Text: `DROP VIEW [IF EXISTS] <tablename> [, ...] [CASCADE | RESTRICT]
`,
		//line sql.y: 1816
		SeeAlso: `WEBDOCS/drop-index.html
`,
	},
	//line sql.y: 1828
	`DROP SEQUENCE`: {
		ShortDescription: `remove a sequence`,
		//line sql.y: 1829
		Category: hDDL,
		//line sql.y: 1830
		Text: `DROP SEQUENCE [IF EXISTS] <sequenceName> [, ...] [CASCADE | RESTRICT]
`,
		//line sql.y: 1831
		SeeAlso: `DROP
`,
	},
	//line sql.y: 1843
	`DROP TABLE`: {
		ShortDescription: `remove a table`,
		//line sql.y: 1844
		Category: hDDL,
		//line sql.y: 1845
		Text: `DROP TABLE [IF EXISTS] <tablename> [, ...] [CASCADE | RESTRICT]
`,
		//line sql.y: 1846
		SeeAlso: `WEBDOCS/drop-table.html
`,
	},
	//line sql.y: 1858
	`DROP INDEX`: {
		ShortDescription: `remove an index`,
		//line sql.y: 1859
		Category: hDDL,
		//line sql.y: 1860
		Text: `DROP INDEX [IF EXISTS] <idxname> [, ...] [CASCADE | RESTRICT]
`,
		//line sql.y: 1861
		SeeAlso: `WEBDOCS/drop-index.html
`,
	},
	//line sql.y: 1881
	`DROP DATABASE`: {
		ShortDescription: `remove a database`,
		//line sql.y: 1882
		Category: hDDL,
		//line sql.y: 1883
		Text: `DROP DATABASE [IF EXISTS] <databasename> [CASCADE | RESTRICT]
`,
		//line sql.y: 1884
		SeeAlso: `WEBDOCS/drop-database.html
`,
	},
	//line sql.y: 1904
	`DROP USER`: {
		ShortDescription: `remove a user`,
		//line sql.y: 1905
		Category: hPriv,
		//line sql.y: 1906
		Text: `DROP USER [IF EXISTS] <user> [, ...]
`,
		//line sql.y: 1907
		SeeAlso: `CREATE USER, SHOW USERS
`,
	},
	//line sql.y: 1919
	`DROP ROLE`: {
		ShortDescription: `remove a role`,
		//line sql.y: 1920
		Category: hPriv,
		//line sql.y: 1921
		Text: `DROP ROLE [IF EXISTS] <role> [, ...]
`,
		//line sql.y: 1922
		SeeAlso: `CREATE ROLE, SHOW ROLES
`,
	},
	//line sql.y: 1944
	`EXPLAIN`: {
		ShortDescription: `show the logical plan of a query`,
		//line sql.y: 1945
		Category: hMisc,
		//line sql.y: 1946
		Text: `
EXPLAIN <statement>
EXPLAIN [( [PLAN ,] <planoptions...> )] <statement>

Explainable statements:
    SELECT, CREATE, DROP, ALTER, INSERT, UPSERT, UPDATE, DELETE,
    SHOW, EXPLAIN, EXECUTE

Plan options:
    TYPES, EXPRS, METADATA, QUALIFY, INDENT, VERBOSE, DIST_SQL

`,
		//line sql.y: 1957
		SeeAlso: `WEBDOCS/explain.html
`,
	},
	//line sql.y: 2018
	`PREPARE`: {
		ShortDescription: `prepare a statement for later execution`,
		//line sql.y: 2019
		Category: hMisc,
		//line sql.y: 2020
		Text: `PREPARE <name> [ ( <types...> ) ] AS <query>
`,
		//line sql.y: 2021
		SeeAlso: `EXECUTE, DEALLOCATE, DISCARD
`,
	},
	//line sql.y: 2043
	`EXECUTE`: {
		ShortDescription: `execute a statement prepared previously`,
		//line sql.y: 2044
		Category: hMisc,
		//line sql.y: 2045
		Text: `EXECUTE <name> [ ( <exprs...> ) ]
`,
		//line sql.y: 2046
		SeeAlso: `PREPARE, DEALLOCATE, DISCARD
`,
	},
	//line sql.y: 2069
	`DEALLOCATE`: {
		ShortDescription: `remove a prepared statement`,
		//line sql.y: 2070
		Category: hMisc,
		//line sql.y: 2071
		Text: `DEALLOCATE [PREPARE] { <name> | ALL }
`,
		//line sql.y: 2072
		SeeAlso: `PREPARE, EXECUTE, DISCARD
`,
	},
	//line sql.y: 2092
	`GRANT`: {
		ShortDescription: `define access privileges and role memberships`,
		//line sql.y: 2093
		Category: hPriv,
		//line sql.y: 2094
		Text: `
Grant privileges:
  GRANT {ALL | <privileges...> } ON <targets...> TO <grantees...>
Grant role membership (CCL only):
  GRANT <roles...> TO <grantees...> [WITH ADMIN OPTION]

Privileges:
  CREATE, DROP, GRANT, SELECT, INSERT, DELETE, UPDATE

Targets:
  DATABASE <databasename> [, ...]
  [TABLE] [<databasename> .] { <tablename> | * } [, ...]

`,
		//line sql.y: 2107
		SeeAlso: `REVOKE, WEBDOCS/grant.html
`,
	},
	//line sql.y: 2123
	`REVOKE`: {
		ShortDescription: `remove access privileges and role memberships`,
		//line sql.y: 2124
		Category: hPriv,
		//line sql.y: 2125
		Text: `
Revoke privileges:
  REVOKE {ALL | <privileges...> } ON <targets...> FROM <grantees...>
Revoke role membership (CCL only):
  REVOKE [ADMIN OPTION FOR] <roles...> FROM <grantees...>

Privileges:
  CREATE, DROP, GRANT, SELECT, INSERT, DELETE, UPDATE

Targets:
  DATABASE <databasename> [, <databasename>]...
  [TABLE] [<databasename> .] { <tablename> | * } [, ...]

`,
		//line sql.y: 2138
		SeeAlso: `GRANT, WEBDOCS/revoke.html
`,
	},
	//line sql.y: 2193
	`RESET`: {
		ShortDescription: `reset a session variable to its default value`,
		//line sql.y: 2194
		Category: hCfg,
		//line sql.y: 2195
		Text: `RESET [SESSION] <var>
`,
		//line sql.y: 2196
		SeeAlso: `RESET CLUSTER SETTING, WEBDOCS/set-vars.html
`,
	},
	//line sql.y: 2208
	`RESET CLUSTER SETTING`: {
		ShortDescription: `reset a cluster setting to its default value`,
		//line sql.y: 2209
		Category: hCfg,
		//line sql.y: 2210
		Text: `RESET CLUSTER SETTING <var>
`,
		//line sql.y: 2211
		SeeAlso: `SET CLUSTER SETTING, RESET
`,
	},
	//line sql.y: 2220
	`USE`: {
		ShortDescription: `set the current database`,
		//line sql.y: 2221
		Category: hCfg,
		//line sql.y: 2222
		Text: `USE <dbname>

"USE <dbname>" is an alias for "SET [SESSION] database = <dbname>".
`,
		//line sql.y: 2225
		SeeAlso: `SET SESSION, WEBDOCS/set-vars.html
`,
	},
	//line sql.y: 2242
	`SCRUB`: {
		ShortDescription: `run checks against databases or tables`,
		//line sql.y: 2243
		Category: hExperimental,
		//line sql.y: 2244
		Text: `
EXPERIMENTAL SCRUB TABLE <table> ...
EXPERIMENTAL SCRUB DATABASE <database>

The various checks that ca be run with SCRUB includes:
  - Physical table data (encoding)
  - Secondary index integrity
  - Constraint integrity (NOT NULL, CHECK, FOREIGN KEY, UNIQUE)
`,
		//line sql.y: 2252
		SeeAlso: `SCRUB TABLE, SCRUB DATABASE
`,
	},
	//line sql.y: 2258
	`SCRUB DATABASE`: {
		ShortDescription: `run scrub checks on a database`,
		//line sql.y: 2259
		Category: hExperimental,
		//line sql.y: 2260
		Text: `
EXPERIMENTAL SCRUB DATABASE <database>
                            [AS OF SYSTEM TIME <expr>]

All scrub checks will be run on the database. This includes:
  - Physical table data (encoding)
  - Secondary index integrity
  - Constraint integrity (NOT NULL, CHECK, FOREIGN KEY, UNIQUE)
`,
		//line sql.y: 2268
		SeeAlso: `SCRUB TABLE, SCRUB
`,
	},
	//line sql.y: 2276
	`SCRUB TABLE`: {
		ShortDescription: `run scrub checks on a table`,
		//line sql.y: 2277
		Category: hExperimental,
		//line sql.y: 2278
		Text: `
SCRUB TABLE <tablename>
            [AS OF SYSTEM TIME <expr>]
            [WITH OPTIONS <option> [, ...]]

Options:
  EXPERIMENTAL SCRUB TABLE ... WITH OPTIONS INDEX ALL
  EXPERIMENTAL SCRUB TABLE ... WITH OPTIONS INDEX (<index>...)
  EXPERIMENTAL SCRUB TABLE ... WITH OPTIONS CONSTRAINT ALL
  EXPERIMENTAL SCRUB TABLE ... WITH OPTIONS CONSTRAINT (<constraint>...)
  EXPERIMENTAL SCRUB TABLE ... WITH OPTIONS PHYSICAL
`,
		//line sql.y: 2289
		SeeAlso: `SCRUB DATABASE, SRUB
`,
	},
	//line sql.y: 2344
	`SET CLUSTER SETTING`: {
		ShortDescription: `change a cluster setting`,
		//line sql.y: 2345
		Category: hCfg,
		//line sql.y: 2346
		Text: `SET CLUSTER SETTING <var> { TO | = } <value>
`,
		//line sql.y: 2347
		SeeAlso: `SHOW CLUSTER SETTING, RESET CLUSTER SETTING, SET SESSION,
WEBDOCS/cluster-settings.html
`,
	},
	//line sql.y: 2368
	`SET SESSION`: {
		ShortDescription: `change a session variable`,
		//line sql.y: 2369
		Category: hCfg,
		//line sql.y: 2370
		Text: `
SET [SESSION] <var> { TO | = } <values...>
SET [SESSION] TIME ZONE <tz>
SET [SESSION] CHARACTERISTICS AS TRANSACTION ISOLATION LEVEL { SNAPSHOT | SERIALIZABLE }

`,
		//line sql.y: 2375
		SeeAlso: `SHOW SESSION, RESET, DISCARD, SHOW, SET CLUSTER SETTING, SET TRANSACTION,
WEBDOCS/set-vars.html
`,
	},
	//line sql.y: 2392
	`SET TRANSACTION`: {
		ShortDescription: `configure the transaction settings`,
		//line sql.y: 2393
		Category: hTxn,
		//line sql.y: 2394
		Text: `
SET [SESSION] TRANSACTION <txnparameters...>

Transaction parameters:
   ISOLATION LEVEL { SNAPSHOT | SERIALIZABLE }
   PRIORITY { LOW | NORMAL | HIGH }

`,
		//line sql.y: 2401
		SeeAlso: `SHOW TRANSACTION, SET SESSION,
WEBDOCS/set-transaction.html
`,
	},
	//line sql.y: 2566
	`SHOW`: {
		//line sql.y: 2567
		Category: hGroup,
		//line sql.y: 2568
		Text: `
SHOW SESSION, SHOW CLUSTER SETTING, SHOW DATABASES, SHOW TABLES, SHOW COLUMNS, SHOW INDEXES,
SHOW CONSTRAINTS, SHOW CREATE TABLE, SHOW CREATE VIEW, SHOW CREATE SEQUENCE, SHOW USERS,
SHOW TRANSACTION, SHOW BACKUP, SHOW JOBS, SHOW QUERIES, SHOW ROLES, SHOW SESSIONS, SHOW SYNTAX,
SHOW TRACE
`,
	},
	//line sql.y: 2602
	`SHOW SESSION`: {
		ShortDescription: `display session variables`,
		//line sql.y: 2603
		Category: hCfg,
		//line sql.y: 2604
		Text: `SHOW [SESSION] { <var> | ALL }
`,
		//line sql.y: 2605
		SeeAlso: `WEBDOCS/show-vars.html
`,
	},
	//line sql.y: 2626
	`SHOW STATISTICS`: {
		ShortDescription: `display table statistics`,
		//line sql.y: 2627
		Category: hMisc,
		//line sql.y: 2628
		Text: `SHOW STATISTICS FOR TABLE <table_name>

Returns the available statistics for a table.
The statistics can include a histogram ID, which can
be used with SHOW HISTOGRAM.
`,
		//line sql.y: 2633
		SeeAlso: `SHOW HISTOGRAM
`,
	},
	//line sql.y: 2641
	`SHOW HISTOGRAM`: {
		ShortDescription: `display histogram`,
		//line sql.y: 2642
		Category: hMisc,
		//line sql.y: 2643
		Text: `SHOW HISTOGRAM <histogram_id>

Returns the data in the histogram with the
given ID (as returned by SHOW STATISTICS).
`,
		//line sql.y: 2647
		SeeAlso: `SHOW STATISTICS
`,
	},
	//line sql.y: 2660
	`SHOW BACKUP`: {
		ShortDescription: `list backup contents`,
		//line sql.y: 2661
		Category: hCCL,
		//line sql.y: 2662
		Text: `SHOW BACKUP <location>
`,
		//line sql.y: 2663
		SeeAlso: `WEBDOCS/show-backup.html
`,
	},
	//line sql.y: 2671
	`SHOW CLUSTER SETTING`: {
		ShortDescription: `display cluster settings`,
		//line sql.y: 2672
		Category: hCfg,
		//line sql.y: 2673
		Text: `
SHOW CLUSTER SETTING <var>
SHOW ALL CLUSTER SETTINGS
`,
		//line sql.y: 2676
		SeeAlso: `WEBDOCS/cluster-settings.html
`,
	},
	//line sql.y: 2693
	`SHOW COLUMNS`: {
		ShortDescription: `list columns in relation`,
		//line sql.y: 2694
		Category: hDDL,
		//line sql.y: 2695
		Text: `SHOW COLUMNS FROM <tablename>
`,
		//line sql.y: 2696
		SeeAlso: `WEBDOCS/show-columns.html
`,
	},
	//line sql.y: 2704
	`SHOW DATABASES`: {
		ShortDescription: `list databases`,
		//line sql.y: 2705
		Category: hDDL,
		//line sql.y: 2706
		Text: `SHOW DATABASES
`,
		//line sql.y: 2707
		SeeAlso: `WEBDOCS/show-databases.html
`,
	},
	//line sql.y: 2715
	`SHOW GRANTS`: {
		ShortDescription: `list grants`,
		//line sql.y: 2716
		Category: hPriv,
		//line sql.y: 2717
		Text: `
Show privilege grants:
  SHOW GRANTS [ON <targets...>] [FOR <users...>]
Show role grants:
  SHOW GRANTS ON ROLE [<roles...>] [FOR <grantees...>]

`,
		//line sql.y: 2723
		SeeAlso: `WEBDOCS/show-grants.html
`,
	},
	//line sql.y: 2736
	`SHOW INDEXES`: {
		ShortDescription: `list indexes`,
		//line sql.y: 2737
		Category: hDDL,
		//line sql.y: 2738
		Text: `SHOW INDEXES FROM <tablename>
`,
		//line sql.y: 2739
		SeeAlso: `WEBDOCS/show-index.html
`,
	},
	//line sql.y: 2757
	`SHOW CONSTRAINTS`: {
		ShortDescription: `list constraints`,
		//line sql.y: 2758
		Category: hDDL,
		//line sql.y: 2759
		Text: `SHOW CONSTRAINTS FROM <tablename>
`,
		//line sql.y: 2760
		SeeAlso: `WEBDOCS/show-constraints.html
`,
	},
	//line sql.y: 2773
	`SHOW QUERIES`: {
		ShortDescription: `list running queries`,
		//line sql.y: 2774
		Category: hMisc,
		//line sql.y: 2775
		Text: `SHOW [CLUSTER | LOCAL] QUERIES
`,
		//line sql.y: 2776
		SeeAlso: `CANCEL QUERY
`,
	},
	//line sql.y: 2792
	`SHOW JOBS`: {
		ShortDescription: `list background jobs`,
		//line sql.y: 2793
		Category: hMisc,
		//line sql.y: 2794
		Text: `SHOW JOBS
`,
		//line sql.y: 2795
		SeeAlso: `CANCEL JOB, PAUSE JOB, RESUME JOB
`,
	},
	//line sql.y: 2803
	`SHOW TRACE`: {
		ShortDescription: `display an execution trace`,
		//line sql.y: 2804
		Category: hMisc,
		//line sql.y: 2805
		Text: `
SHOW [COMPACT] [KV] TRACE FOR SESSION
SHOW [COMPACT] [KV] TRACE FOR <statement>
`,
		//line sql.y: 2808
		SeeAlso: `EXPLAIN
`,
	},
	//line sql.y: 2837
	`SHOW SESSIONS`: {
		ShortDescription: `list open client sessions`,
		//line sql.y: 2838
		Category: hMisc,
		//line sql.y: 2839
		Text: `SHOW [CLUSTER | LOCAL] SESSIONS
`,
	},
	//line sql.y: 2855
	`SHOW TABLES`: {
		ShortDescription: `list tables`,
		//line sql.y: 2856
		Category: hDDL,
		//line sql.y: 2857
		Text: `SHOW TABLES [FROM <databasename> [ . <schemaname> ] ]
`,
		//line sql.y: 2858
		SeeAlso: `WEBDOCS/show-tables.html
`,
	},
	//line sql.y: 2884
	`SHOW SCHEMAS`: {
		ShortDescription: `list schemas`,
		//line sql.y: 2885
		Category: hDDL,
		//line sql.y: 2886
		Text: `SHOW SCHEMAS [FROM <databasename> ]
`,
	},
	//line sql.y: 2898
	`SHOW SYNTAX`: {
		ShortDescription: `analyze SQL syntax`,
		//line sql.y: 2899
		Category: hMisc,
		//line sql.y: 2900
		Text: `SHOW SYNTAX <string>
`,
	},
	//line sql.y: 2909
	`SHOW TRANSACTION`: {
		ShortDescription: `display current transaction properties`,
		//line sql.y: 2910
		Category: hCfg,
		//line sql.y: 2911
		Text: `SHOW TRANSACTION {ISOLATION LEVEL | PRIORITY | STATUS}
`,
		//line sql.y: 2912
		SeeAlso: `WEBDOCS/show-transaction.html
`,
	},
	//line sql.y: 2931
	`SHOW CREATE TABLE`: {
		ShortDescription: `display the CREATE TABLE statement for a table`,
		//line sql.y: 2932
		Category: hDDL,
		//line sql.y: 2933
		Text: `SHOW CREATE TABLE <tablename>
`,
		//line sql.y: 2934
		SeeAlso: `WEBDOCS/show-create-table.html
`,
	},
	//line sql.y: 2942
	`SHOW CREATE VIEW`: {
		ShortDescription: `display the CREATE VIEW statement for a view`,
		//line sql.y: 2943
		Category: hDDL,
		//line sql.y: 2944
		Text: `SHOW CREATE VIEW <viewname>
`,
		//line sql.y: 2945
		SeeAlso: `WEBDOCS/show-create-view.html
`,
	},
	//line sql.y: 2953
	`SHOW CREATE SEQUENCE`: {
		ShortDescription: `display the CREATE SEQUENCE statement for a sequence`,
		//line sql.y: 2954
		Category: hDDL,
		//line sql.y: 2955
		Text: `SHOW CREATE SEQUENCE <seqname>
`,
	},
	//line sql.y: 2963
	`SHOW USERS`: {
		ShortDescription: `list defined users`,
		//line sql.y: 2964
		Category: hPriv,
		//line sql.y: 2965
		Text: `SHOW USERS
`,
		//line sql.y: 2966
		SeeAlso: `CREATE USER, DROP USER, WEBDOCS/show-users.html
`,
	},
	//line sql.y: 2974
	`SHOW ROLES`: {
		ShortDescription: `list defined roles`,
		//line sql.y: 2975
		Category: hPriv,
		//line sql.y: 2976
		Text: `SHOW ROLES
`,
		//line sql.y: 2977
		SeeAlso: `CREATE ROLE, DROP ROLE
`,
	},
	//line sql.y: 3029
	`SHOW RANGES`: {
		ShortDescription: `list ranges`,
		//line sql.y: 3030
		Category: hMisc,
		//line sql.y: 3031
		Text: `
SHOW EXPERIMENTAL_RANGES FROM TABLE <tablename>
SHOW EXPERIMENTAL_RANGES FROM INDEX [ <tablename> @ ] <indexname>
`,
	},
	//line sql.y: 3267
	`PAUSE JOB`: {
		ShortDescription: `pause a background job`,
		//line sql.y: 3268
		Category: hMisc,
		//line sql.y: 3269
		Text: `PAUSE JOB <jobid>
`,
		//line sql.y: 3270
		SeeAlso: `SHOW JOBS, CANCEL JOB, RESUME JOB
`,
	},
	//line sql.y: 3278
	`CREATE TABLE`: {
		ShortDescription: `create a new table`,
		//line sql.y: 3279
		Category: hDDL,
		//line sql.y: 3280
		Text: `
CREATE TABLE [IF NOT EXISTS] <tablename> ( <elements...> ) [<interleave>]
CREATE TABLE [IF NOT EXISTS] <tablename> [( <colnames...> )] AS <source>

Table elements:
   <name> <type> [<qualifiers...>]
   [UNIQUE | INVERTED] INDEX [<name>] ( <colname> [ASC | DESC] [, ...] )
                           [STORING ( <colnames...> )] [<interleave>]
   FAMILY [<name>] ( <colnames...> )
   [CONSTRAINT <name>] <constraint>

Table constraints:
   PRIMARY KEY ( <colnames...> )
   FOREIGN KEY ( <colnames...> ) REFERENCES <tablename> [( <colnames...> )] [ON DELETE {NO ACTION | RESTRICT}] [ON UPDATE {NO ACTION | RESTRICT}]
   UNIQUE ( <colnames... ) [STORING ( <colnames...> )] [<interleave>]
   CHECK ( <expr> )

Column qualifiers:
  [CONSTRAINT <constraintname>] {NULL | NOT NULL | UNIQUE | PRIMARY KEY | CHECK (<expr>) | DEFAULT <expr>}
  FAMILY <familyname>, CREATE [IF NOT EXISTS] FAMILY [<familyname>]
  REFERENCES <tablename> [( <colnames...> )] [ON DELETE {NO ACTION | RESTRICT}] [ON UPDATE {NO ACTION | RESTRICT}]
  COLLATE <collationname>
  AS ( <expr> ) STORED

Interleave clause:
   INTERLEAVE IN PARENT <tablename> ( <colnames...> ) [CASCADE | RESTRICT]

`,
		//line sql.y: 3307
		SeeAlso: `SHOW TABLES, CREATE VIEW, SHOW CREATE TABLE,
WEBDOCS/create-table.html
WEBDOCS/create-table-as.html
`,
	},
	//line sql.y: 3818
	`CREATE SEQUENCE`: {
		ShortDescription: `create a new sequence`,
		//line sql.y: 3819
		Category: hDDL,
		//line sql.y: 3820
		Text: `
CREATE SEQUENCE <seqname>
  [INCREMENT <increment>]
  [MINVALUE <minvalue> | NO MINVALUE]
  [MAXVALUE <maxvalue> | NO MAXVALUE]
  [START [WITH] <start>]
  [CACHE <cache>]
  [NO CYCLE]

`,
		//line sql.y: 3829
		SeeAlso: `CREATE TABLE
`,
	},
	//line sql.y: 3882
	`TRUNCATE`: {
		ShortDescription: `empty one or more tables`,
		//line sql.y: 3883
		Category: hDML,
		//line sql.y: 3884
		Text: `TRUNCATE [TABLE] <tablename> [, ...] [CASCADE | RESTRICT]
`,
		//line sql.y: 3885
		SeeAlso: `WEBDOCS/truncate.html
`,
	},
	//line sql.y: 3893
	`CREATE USER`: {
		ShortDescription: `define a new user`,
		//line sql.y: 3894
		Category: hPriv,
		//line sql.y: 3895
		Text: `CREATE USER [IF NOT EXISTS] <name> [ [WITH] PASSWORD <passwd> ]
`,
		//line sql.y: 3896
		SeeAlso: `DROP USER, SHOW USERS, WEBDOCS/create-user.html
`,
	},
	//line sql.y: 3918
	`CREATE ROLE`: {
		ShortDescription: `define a new role`,
		//line sql.y: 3919
		Category: hPriv,
		//line sql.y: 3920
		Text: `CREATE ROLE [IF NOT EXISTS] <name>
`,
		//line sql.y: 3921
		SeeAlso: `DROP ROLE, SHOW ROLES
`,
	},
	//line sql.y: 3933
	`CREATE VIEW`: {
		ShortDescription: `create a new view`,
		//line sql.y: 3934
		Category: hDDL,
		//line sql.y: 3935
		Text: `CREATE VIEW <viewname> [( <colnames...> )] AS <source>
`,
		//line sql.y: 3936
		SeeAlso: `CREATE TABLE, SHOW CREATE VIEW, WEBDOCS/create-view.html
`,
	},
	//line sql.y: 3950
	`CREATE INDEX`: {
		ShortDescription: `create a new index`,
		//line sql.y: 3951
		Category: hDDL,
		//line sql.y: 3952
		Text: `
CREATE [UNIQUE | INVERTED] INDEX [IF NOT EXISTS] [<idxname>]
       ON <tablename> ( <colname> [ASC | DESC] [, ...] )
       [STORING ( <colnames...> )] [<interleave>]

Interleave clause:
   INTERLEAVE IN PARENT <tablename> ( <colnames...> ) [CASCADE | RESTRICT]

`,
		//line sql.y: 3960
		SeeAlso: `CREATE TABLE, SHOW INDEXES, SHOW CREATE INDEX,
WEBDOCS/create-index.html
`,
	},
	//line sql.y: 4154
	`RELEASE`: {
		ShortDescription: `complete a retryable block`,
		//line sql.y: 4155
		Category: hTxn,
		//line sql.y: 4156
		Text: `RELEASE [SAVEPOINT] cockroach_restart
`,
		//line sql.y: 4157
		SeeAlso: `SAVEPOINT, WEBDOCS/savepoint.html
`,
	},
	//line sql.y: 4165
	`RESUME JOB`: {
		ShortDescription: `resume a background job`,
		//line sql.y: 4166
		Category: hMisc,
		//line sql.y: 4167
		Text: `RESUME JOB <jobid>
`,
		//line sql.y: 4168
		SeeAlso: `SHOW JOBS, CANCEL JOB, PAUSE JOB
`,
	},
	//line sql.y: 4176
	`SAVEPOINT`: {
		ShortDescription: `start a retryable block`,
		//line sql.y: 4177
		Category: hTxn,
		//line sql.y: 4178
		Text: `SAVEPOINT cockroach_restart
`,
		//line sql.y: 4179
		SeeAlso: `RELEASE, WEBDOCS/savepoint.html
`,
	},
	//line sql.y: 4194
	`BEGIN`: {
		ShortDescription: `start a transaction`,
		//line sql.y: 4195
		Category: hTxn,
		//line sql.y: 4196
		Text: `
BEGIN [TRANSACTION] [ <txnparameter> [[,] ...] ]
START TRANSACTION [ <txnparameter> [[,] ...] ]

Transaction parameters:
   ISOLATION LEVEL { SNAPSHOT | SERIALIZABLE }
   PRIORITY { LOW | NORMAL | HIGH }

`,
		//line sql.y: 4204
		SeeAlso: `COMMIT, ROLLBACK, WEBDOCS/begin-transaction.html
`,
	},
	//line sql.y: 4217
	`COMMIT`: {
		ShortDescription: `commit the current transaction`,
		//line sql.y: 4218
		Category: hTxn,
		//line sql.y: 4219
		Text: `
COMMIT [TRANSACTION]
END [TRANSACTION]
`,
		//line sql.y: 4222
		SeeAlso: `BEGIN, ROLLBACK, WEBDOCS/commit-transaction.html
`,
	},
	//line sql.y: 4246
	`ROLLBACK`: {
		ShortDescription: `abort the current transaction`,
		//line sql.y: 4247
		Category: hTxn,
		//line sql.y: 4248
		Text: `ROLLBACK [TRANSACTION] [TO [SAVEPOINT] cockroach_restart]
`,
		//line sql.y: 4249
		SeeAlso: `BEGIN, COMMIT, SAVEPOINT, WEBDOCS/rollback-transaction.html
`,
	},
	//line sql.y: 4362
	`CREATE DATABASE`: {
		ShortDescription: `create a new database`,
		//line sql.y: 4363
		Category: hDDL,
		//line sql.y: 4364
		Text: `CREATE DATABASE [IF NOT EXISTS] <name>
`,
		//line sql.y: 4365
		SeeAlso: `WEBDOCS/create-database.html
`,
	},
	//line sql.y: 4434
	`INSERT`: {
		ShortDescription: `create new rows in a table`,
		//line sql.y: 4435
		Category: hDML,
		//line sql.y: 4436
		Text: `
INSERT INTO <tablename> [[AS] <name>] [( <colnames...> )]
       <selectclause>
       [ON CONFLICT [( <colnames...> )] {DO UPDATE SET ... [WHERE <expr>] | DO NOTHING}]
       [RETURNING <exprs...>]
`,
		//line sql.y: 4441
		SeeAlso: `UPSERT, UPDATE, DELETE, WEBDOCS/insert.html
`,
	},
	//line sql.y: 4460
	`UPSERT`: {
		ShortDescription: `create or replace rows in a table`,
		//line sql.y: 4461
		Category: hDML,
		//line sql.y: 4462
		Text: `
UPSERT INTO <tablename> [AS <name>] [( <colnames...> )]
       <selectclause>
       [RETURNING <exprs...>]
`,
		//line sql.y: 4466
		SeeAlso: `INSERT, UPDATE, DELETE, WEBDOCS/upsert.html
`,
	},
	//line sql.y: 4571
	`UPDATE`: {
		ShortDescription: `update rows of a table`,
		//line sql.y: 4572
		Category: hDML,
		//line sql.y: 4573
		Text: `
UPDATE <tablename> [[AS] <name>]
       SET ...
       [WHERE <expr>]
       [ORDER BY <exprs...>]
       [LIMIT <expr>]
       [RETURNING <exprs...>]
`,
		//line sql.y: 4580
		SeeAlso: `INSERT, UPSERT, DELETE, WEBDOCS/update.html
`,
	},
	//line sql.y: 4750
	`<SELECTCLAUSE>`: {
		ShortDescription: `access tabular data`,
		//line sql.y: 4751
		Category: hDML,
		//line sql.y: 4752
		Text: `
Select clause:
  TABLE <tablename>
  VALUES ( <exprs...> ) [ , ... ]
  SELECT ... [ { INTERSECT | UNION | EXCEPT } [ ALL | DISTINCT ] <selectclause> ]
`,
	},
	//line sql.y: 4763
	`SELECT`: {
		ShortDescription: `retrieve rows from a data source and compute a result`,
		//line sql.y: 4764
		Category: hDML,
		//line sql.y: 4765
		Text: `
SELECT [DISTINCT [ ON ( <expr> [ , ... ] ) ] ]
       { <expr> [[AS] <name>] | [ [<dbname>.] <tablename>. ] * } [, ...]
       [ FROM <source> ]
       [ WHERE <expr> ]
       [ GROUP BY <expr> [ , ... ] ]
       [ HAVING <expr> ]
       [ WINDOW <name> AS ( <definition> ) ]
       [ { UNION | INTERSECT | EXCEPT } [ ALL | DISTINCT ] <selectclause> ]
       [ ORDER BY <expr> [ ASC | DESC ] [, ...] ]
       [ LIMIT { <expr> | ALL } ]
       [ OFFSET <expr> [ ROW | ROWS ] ]
`,
		//line sql.y: 4777
		SeeAlso: `WEBDOCS/select.html
`,
	},
	//line sql.y: 4852
	`TABLE`: {
		ShortDescription: `select an entire table`,
		//line sql.y: 4853
		Category: hDML,
		//line sql.y: 4854
		Text: `TABLE <tablename>
`,
		//line sql.y: 4855
		SeeAlso: `SELECT, VALUES, WEBDOCS/table-expressions.html
`,
	},
	//line sql.y: 5122
	`VALUES`: {
		ShortDescription: `select a given set of values`,
		//line sql.y: 5123
		Category: hDML,
		//line sql.y: 5124
		Text: `VALUES ( <exprs...> ) [, ...]
`,
		//line sql.y: 5125
		SeeAlso: `SELECT, TABLE, WEBDOCS/table-expressions.html
`,
	},
	//line sql.y: 5226
	`<SOURCE>`: {
		ShortDescription: `define a data source for SELECT`,
		//line sql.y: 5227
		Category: hDML,
		//line sql.y: 5228
		Text: `
Data sources:
  <tablename> [ @ { <idxname> | <indexhint> } ]
  <tablefunc> ( <exprs...> )
  ( { <selectclause> | <source> } )
  <source> [AS] <alias> [( <colnames...> )]
  <source> { [INNER] | { LEFT | RIGHT | FULL } [OUTER] } JOIN <source> ON <expr>
  <source> { [INNER] | { LEFT | RIGHT | FULL } [OUTER] } JOIN <source> USING ( <colnames...> )
  <source> NATURAL { [INNER] | { LEFT | RIGHT | FULL } [OUTER] } JOIN <source>
  <source> CROSS JOIN <source>
  <source> WITH ORDINALITY
  '[' EXPLAIN ... ']'
  '[' SHOW ... ']'

Index hints:
  '{' FORCE_INDEX = <idxname> [, ...] '}'
  '{' NO_INDEX_JOIN [, ...] '}'

`,
		//line sql.y: 5246
		SeeAlso: `WEBDOCS/table-expressions.html
`,
	},
}
